Issue 123771 - OSBA OOXML improvement project - use case 4 - annotations on text ranges
Summary: OSBA OOXML improvement project - use case 4 - annotations on text ranges
Status: CLOSED FIXED
Alias: None
Product: Writer
Classification: Application
Component: code (show other issues)
Version: 4.1.0-dev
Hardware: All All
: P3 Normal (vote)
Target Milestone: 4.1.0
Assignee: Oliver-Rainer Wittmann
QA Contact:
URL:
Keywords:
Depends on: 97631 113059 123792
Blocks: 122598 123877
  Show dependency tree
 
Reported: 2013-11-28 14:22 UTC by Oliver-Rainer Wittmann
Modified: 2017-05-20 10:35 UTC (History)
2 users (show)

See Also:
Issue Type: ENHANCEMENT
Latest Confirmation in: ---
Developer Difficulty: ---


Attachments
test document in OOXML format provided by OSBA patches (12.13 KB, application/octet-stream)
2013-12-13 08:22 UTC, Oliver-Rainer Wittmann
no flags Details
test document in ODF format provided by OSBA patches (10.09 KB, application/octet-stream)
2013-12-13 08:22 UTC, Oliver-Rainer Wittmann
no flags Details

Note You need to log in before you can comment on or make changes to this issue.
Description Oliver-Rainer Wittmann 2013-11-28 14:22:37 UTC
Enhancement issue to integrate OSBA OOXML improvement project's use case 4 patches.

Beside the intrinsic integration needed corrections and improvements will be also made.
Comment 1 Oliver-Rainer Wittmann 2013-11-28 14:23:39 UTC
taking over and establish connection to main issue
Comment 2 SVN Robot 2013-11-28 16:01:25 UTC
"orw" committed SVN revision 1546391 into branches/ooxml-osba:
123771: integration of OSBA OOXML improvement project's use case 4 patches
Comment 3 Oliver-Rainer Wittmann 2013-11-28 16:20:21 UTC
(In reply to SVN Robot from comment #2)
> "orw" committed SVN revision 1546391 into branches/ooxml-osba:
> 123771: integration of OSBA OOXML improvement project's use case 4 patches

Committed the intrinsic patches on branch ooxml-osba.

Unfortunately, the changes for the RTF filter, the *.docx export and the *.xlsx export are not usable as they based on code which is not available in AOO.
Comment 4 SVN Robot 2013-11-28 16:57:15 UTC
"orw" committed SVN revision 1546395 into branches/ooxml-osba:
123771: *.docx import - handle properties of annotations
Comment 5 Oliver-Rainer Wittmann 2013-11-29 08:15:41 UTC
(In reply to SVN Robot from comment #4)
> "orw" committed SVN revision 1546395 into branches/ooxml-osba:
> 123771: *.docx import - handle properties of annotations

The introduced feature to import the author initials from an annotation when importing a *.docx document does not work with the provided patches from the OSBA OOXML improvement project. The corresponding import code lacks the handling of properties. The above patch fixes this problem.
Comment 6 SVN Robot 2013-11-29 15:03:17 UTC
"orw" committed SVN revision 1546574 into branches/ooxml-osba:
123771: fix <Fieldmark> implementation for OSBA OOXML improvement use case 4
Comment 7 Oliver-Rainer Wittmann 2013-11-29 15:18:31 UTC
(In reply to SVN Robot from comment #6)
> "orw" committed SVN revision 1546574 into branches/ooxml-osba:
> 123771: fix <Fieldmark> implementation for OSBA OOXML improvement use case 4

The ODF export of annotations on a text range does not work with the provided patches from the OSBA OOXML improvement project.
The reason is that the implementation uses the 'Fieldmark' feature. A first version of this feature had been contributed by SUSE/Novell to OpenOffice in earlier days (1). It was not stable enough to activate it in this state - see comments in bug 33737 from July 2009. No further development work on this feature taking place on SUSE'/Novell's go-oo and nowadays on LibreOffice had been contributed. Thus, the above changes fixes some problems in code of this feature to get the OSBA OOXML improvement use case 4 work:
- Fieldmark instance does not contain its special starting character. Thus, the Fieldmark was not found during the ODF export.
- UNO-API object representing a Fieldmark was not initialized correctly. Thus, the ODF export of an annotation on a text range does not work - it caused an exception.

(1) In years 2008 and 2009 - before OpenOffice found its new home at ASF. It was part of the work for a more general solution for bug 33737.
Comment 8 SVN Robot 2013-12-02 09:28:12 UTC
"orw" committed SVN revision 1546934 into branches/ooxml-osba:
123771: ODF export: export annotation's author initials in own namespace only...
Comment 9 Oliver-Rainer Wittmann 2013-12-02 09:34:37 UTC
(In reply to SVN Robot from comment #8)
> "orw" committed SVN revision 1546934 into branches/ooxml-osba:
> 123771: ODF export: export annotation's author initials in own namespace
> only...

The introduced annotation's author initials are currently not standardized in ODF 1.2. A corresponding proposal is available at the OASIS ODF TC since Aug. 2012 - see JIRA issue OFFICE-3776 (https://tools.oasis-open.org/issues/browse/OFFICE-3776). Unfortunately, nobody is driving this proposal at the OASIS ODF TC and a TC's question from Oct. 2012 is still unanswered.
Thus, the above changes export the annotation's author initials in an own namespace and only if file format "ODF 1.2 (extended)" is chosen. This assures ODF conformance of the created ODF text documents.
Comment 10 Oliver-Rainer Wittmann 2013-12-02 10:09:39 UTC
The existing *.docx import of annotations does not work correct:
- the content of the annotations is not imported correct - the content of all annotations is set as the content of each annotation
--> bug 113059
- author and creation date is not imported
--> bug 97631

The changes for OSBA OOXML improvement project use case 4 are not working well:
- the 'Fieldmark' feature does not seem to be stable enough.
- only annotations on text ranges inside one paragraph are supported.
- overlapping annotations can be created, but are not supported.
- WW8 import/export not adopted to support annotations on text ranges.
--> new issue to complete feature 'annotations on text ranges'.
Comment 11 Oliver-Rainer Wittmann 2013-12-02 14:11:34 UTC
integration of patches from OSBA OOXML improvement project's use case 4 inclusive minimal needed fixes done on branch ooxml-osba

continuing  development work on blocking issues also on branch ooxml-osba
Comment 12 Oliver-Rainer Wittmann 2013-12-13 08:22:12 UTC
Created attachment 82087 [details]
test document in OOXML format provided by OSBA patches
Comment 13 Oliver-Rainer Wittmann 2013-12-13 08:22:58 UTC
Created attachment 82088 [details]
test document in ODF format provided by OSBA patches
Comment 14 fanyuzhen 2013-12-16 09:44:16 UTC
Per description of test documents in specification: http://www.osb-alliance.de/fileadmin/Working_Groups/OfficeInteroperability/Project1/SpecificationOOXMLimprovements_EN_V06.pdf:

1. "These are normally .docx files containing certain layout elements as well as corresponding PDF files (exported from Microsoft Office) that portray the desired appearance."
2. "Furthermore, LibreOffice/OpenOffice must be able to save the test document as a valid ODF"

Questions: 
1. any corresponding PDF file exported from MS Office for attachment 82087 [details] (fdo38244.docx)?
2. any corresponding OOXML file from which attachment 82088 [details](fdo38244.odt) saved from?

Note: it seems that fdo38244.docx and fdo38244.odt have no relationship with different content.
Comment 15 Oliver-Rainer Wittmann 2013-12-16 09:56:16 UTC
(In reply to fanyuzhen from comment #14)
> Per description of test documents in specification:
> http://www.osb-alliance.de/fileadmin/Working_Groups/OfficeInteroperability/
> Project1/SpecificationOOXMLimprovements_EN_V06.pdf:
> 
> 1. "These are normally .docx files containing certain layout elements as
> well as corresponding PDF files (exported from Microsoft Office) that
> portray the desired appearance."
> 2. "Furthermore, LibreOffice/OpenOffice must be able to save the test
> document as a valid ODF"
> 
> Questions: 
> 1. any corresponding PDF file exported from MS Office for attachment 82087 [details]
> [details] (fdo38244.docx)?
> 2. any corresponding OOXML file from which attachment 82088 [details]
> [details](fdo38244.odt) saved from?
> 
> Note: it seems that fdo38244.docx and fdo38244.odt have no relationship with
> different content.

The attached test documents are the ones that are provided with the corresponding patches. I do not think that these test documents are the ones that are mentioned in the specification for the OSBA OOXML improvement project.
Comment 16 SVN Robot 2013-12-19 12:36:17 UTC
"orw" committed SVN revision 1552294 into trunk:
123771: integration of OSBA OOXML improvement project's use case 4 patches
Comment 17 SVN Robot 2013-12-19 12:36:21 UTC
"orw" committed SVN revision 1552295 into trunk:
123771: *.docx import - handle properties of annotations
Comment 18 SVN Robot 2013-12-19 12:49:19 UTC
"orw" committed SVN revision 1552300 into trunk:
123771: fix <Fieldmark> implementation for OSBA OOXML improvement use case 4
Comment 19 SVN Robot 2013-12-19 13:03:05 UTC
"orw" committed SVN revision 1552307 into trunk:
123771: ODF export: export annotation's author initials in own namespace only...
Comment 20 Oliver-Rainer Wittmann 2014-01-02 14:47:51 UTC
solved on trunk for next release